# API Reference

- [Get Blockchains & Tokens](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/get-blockchains-and-tokens.md): Get all blockchains, tokens and swappers meta data
- [Get Best Route](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/get-best-route.md): Get the best route for swapping X to Y
- [Get All Possible Routes](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/get-all-possible-routes.md): Get all possible routes for swapping X to Y
- [Confirm Route](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/confirm-route.md): Confirm the desired route by the user and pass user's wallets for executing the route
- [Create Transaction](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/create-transaction.md): Create the transaction for current step
- [Check Transaction Status](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/check-transaction-status.md): Track the status of the transaction for the current step
- [Check  Approve Transaction Status](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/check-approve-transaction-status.md): Check status of approve transaction
- [Report Transaction Failure](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/report-transaction-failure.md): Report failures on signing or sending the transaction
- [Get Custom Token](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/get-custom-token.md): Get metadata of a custom token
- [Get Address Token Balance](https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference/get-address-token-balance.md): Get details of a list of wallets, including their explorer Url & balance


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.rango.exchange/api-integration/main-api-multi-step/api-reference.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
